# $Id: Palette.pl,v 1.1 1996/07/26 05:14:24 pedja Exp $
#   Palette.pl: converted from the original Palette.wos
#   The original file contains the following notice:
#
#   You may freely copy, distribute, and reuse the code in this example.
#   NeXT disclaims any warranty of any kind, expressed or  implied, as to its
#   fitness for any particular use.
#
#	 Written by Nico Popp
#
#   Palette is a subcomponent (or child component) that's nested in the
#   component associated with the page Main. It messages the parent
#   component Main using a WOAction object callBack. 
# 
#   When the user clicks on digit, the Palette's click method is
#   triggered. This sets the value of the selection variable to the
#   digit the user clicked on. Since the selection variable of the
#   child component is tied to the number variable of the parent (in the
#   Main.wod declarations file), the number variable is modified
#   accordingly. Next, the click method sends the WOAction
#   object callBack an invoke message. This invokes the displaySelection
#   method in the parent's script Main.pl. Finally, the displaySelection
#   method generates a new Main page that reflects the digit clicked by
#   the user.

package WO::Component::Palette;
use WOPerl;

@IVARS=qw(digits digit selection);
# digits, digit:  repetition's list and item
# selection: the clicked digit

@ACTIONS=qw(callBack);
#action callBack; 
#    // A WOAction object. This is a mechanism for a component to call back
#    // its parent page (or component). Take a look at the corresponding
#    // declaration in Main.wod.

#  Create the array of digits 
#  (both for request handling and response generation)
sub awake 
{
  my $self=shift;
  $self->{'digits'} = [1, 2, 3, 4, 5, 6, 7, 8, 9];
}

#  Invoked by a WOHyperlink when it has been clicked 
sub click 
{
  my $self=shift;
  $self->{'selection'} = $self->{'digit'};
  return $self->{'callBack'}->invoke();
}

'WO::Component::Palette';
#EOF
