# $Id: Buy.pl,v 1.1 1996/07/26 05:14:31 pedja Exp $

# Buy.pl: converted from the original Buy.wos
# The original file contains the following notice:
#
# You may freely copy, distribute and reuse the code in this example.
# NeXT disclaims any warranty of any kind, expressed or implied, as to
# its fitness for any particular use.
#
# This script file declares a persistent variable, selectedSailboards.
# Whereas the options variable in Main.wos can easily be created and
# initialized in awake (it's always set to the same two strings),
# selectedSailboards must be stored between transactions. Its value is
# dynamic--it's specified by the user.
#
# WOF takes care of saving and restoring the values of persistent variables
# between transactions.


package WO::CyberWind::Buy;
use WOPerl;
@PERSISTENT=qw(selectedSailboards);
@IVARS=qw(allSailboards sailboard);

sub awake {
  my $self=shift;

  # The following statements use methods to create and fill array
  # and dictionary objects instead of using WebScript's @ syntax
  # for creating static objects.
  $self->{'allSailboards'} = [
      {"name" => "Tiga 2.50", "price" => 850 },
      {"name" => "Mistral Electron", "price" => 1150 },
      {"name" => "Seatrend 8.6", "price" => 1200 },
    ];
  return $self;
}

sub descriptionForSailboard
{
  my $self=shift;
  if ($self->{'sailboard'}) {
    return $self->{'sailboard'}->{'name'} . " - \$" .
      $self->{'sailboard'}->{'price'};
  }
  return undef;
}

sub customerInfoPage
{ 
  my $self=shift;
  my $nextPage = $WOApp->pageWithName("CustomerInfo"); 
  $nextPage->setSelectedSailboards($self->{'selectedSailboards'});
  return $nextPage;
}

'WO::CyberWind::Buy';
#EOF
