# $Id: Footer.pl,v 1.1 1996/07/26 05:14:45 pedja Exp $
# Footer.pl: converted from the original Footer.wos
# The original file contains the following notice:
#
# You may freely copy, distribute and reuse the code in this example.
# NeXT disclaims any warranty of any kind, expressed or implied, as to
# its fitness for any particular use.
#
# This is a simple example of a reusable component that can be added as a 
# footer to all the pages in an application.

package WO::CyberWind::Footer;
use WOPerl;

@IVARS=qw(date);

sub formattedDate
{
  my $self=shift;
  $self->{'date'} = NSCalendarDate->calendarDate;
    
  # Creates a date formatted like this one:  24 Jan 1996 21:38:54.
  return $self->{'date'}->descriptionWithCalendarFormat("%d %b %Y %H:%M:%S");
}

sub willPrepareForRequestInContext
{
  my $self=shift;
  $self->incrementInteractionsCount;
  $self->incrementSessionInteractionsCount;
  return nil;
}

sub incrementInteractionsCount
{
  my $self=shift;
  # You can access script variables in two ways:
  # 	    1. with valueForKey: and setValue:forKey: methods
  #	    2. with variableName and setVariableName: methods
  # The following statements use 1.  See incrementSessionInteractionsCount
  # for an example of 2.
  my $interactionsCount = $WOApp->valueForKey("interactionsCount");
  $WOApp->takeValueForKey(1+$interactionsCount,"interactionsCount");
}

sub incrementSessionInteractionsCount
{
  my $self=shift;
  # This is the more common way to set and get script variables.
  # In WOPerl, you can send messages like:
  #	    $WOApp->aVariable;  # returns the variable named aVariable.
  #	    $WOApp->setAVariable(newValue);  # sets aVariable to newValue.
  # without declaring or defining the methods aVariable and
  # setAVariable.
  
  my $sessionInteractionsCount = $WOApp->sessionInteractionsCount;
  $WOApp->setSessionInteractionsCount(1+$sessionInteractionsCount);
}

'WO::CyberWind::Footer';
# EOF
