# $Id: SelectedCars.pl,v 1.1 1996/07/26 05:17:10 pedja Exp $
# SelectedCars.pl: converted from the original SelectedCars.wos
# The original file contains the following notice:
#
# You may freely copy, distribute, and reuse the code in this example.
# NeXT disclaims any warranty of any kind, expressed or  implied, as to its
# fitness for any particular use.
#
# Written by Jean-Marie Hullot
#
# The SelectedCars component represents the second page of the application.
# It displays a list of cars that match user criteria, 

package WO::DodgeLite::SelectedCars;
use WOPerl;

@IVARS=qw(models types prices sortOrder car errorMessage);
@PERSISTENT=(selectedCars);
%FLAGS=(
  'rawSet' => 1,
);

sub fetchSelectedCars {
  my $self=shift;
  my $theCars = $WOApp->allCars;
  my $carsEnumerator = $theCars->objectEnumerator;
  my($theCar, $theModel, $theType);
  my($thePrice, $maxPrice, $aPrice);
  my $pricesEnumerator = $self->{'prices'}->objectEnumerator;
    
  $maxPrice = 0;
  while (!nil($aPrice = $pricesEnumerator->nextObject)) {
    if ($aPrice > $maxPrice) {
      $maxPrice = $aPrice;
    }
  }
    
  $maxPrice = $maxPrice + 999;
  $self->{'selectedCars'}=NSMutableArray->array;
  while (!nil($theCar = $carsEnumerator->nextObject)) {
    $theModel=$WOApp->modelsDict->objectForKey($theCar->objectForKey("model"));
    $theType=$WOApp->typesDict->objectForKey($theCar->objectForKey("type"));
    $thePrice = $theCar->objectForKey("basePrice");
    if ($self->{'models'}->containsObject($theModel) &&
	$self->{'types'}->containsObject($theType) &&
	($thePrice < $maxPrice)) {
      $self->insertSelectedCar($theCar);
    }
  }
  if (!$self->{'selectedCars'}->count) {
    $self->{'errorMessage'} = "Sorry.  There is no car in the database that satisfies your selection criteria.";
  } else { $self->sort };
  return;
}

# Insert with prices in ascending order.
sub insertSelectedCar
{
  my($self,$aCar)=@_;
  my $carsEnumerator = $self->{'selectedCars'}->objectEnumerator;
  my $currentCar;
  my $done=0;
  my $aPrice = $aCar->objectForKey("basePrice");
    
  while (!$done && !nil($currentCar = $carsEnumerator->nextObject)) {
    if ($aPrice < $currentCar->objectForKey("basePrice")) {
      $self->{'selectedCars'}->insertObjectAtIndex($aCar,
		   $self->{'selectedCars'}->indexOfObject($currentCar));
      $done = 1;
    }
  }
  if (!$done) {
    $self->{'selectedCars'}->addObject($aCar);
  }
  return;
}


sub sort {
  my $self=shift;
  my($key, $namesList);
  my($currentName, $namesEnumerator);
  my($currentCar, $carsEnumerator);
  my($tmpCars);
    
  my $so=$self->{'sortOrder'};
  if ($so eq "Model") {
    $key = "model";
    $namesList = $WOApp->modelsDict->allKeys;
  } elsif ($so eq "Type") {
    $key = "type";
    $namesList = $WOApp->typesDict->allKeys;
  } else {
    # already sorted by price
    return 0;
  }
    
  print "SORTING by $key\n";
  $tmpCars = NSMutableArray->array;
  $namesEnumerator = $namesList->objectEnumerator;
  while ($currentName = $namesEnumerator->nextObject) {
    $carsEnumerator = $self->{'selectedCars'}->objectEnumerator;
    while ($currentCar = $carsEnumerator->nextObject) {
      if ($currentCar->objectForKey($key)->isEqual($currentName)) {
	$tmpCars->addObject($currentCar);
      }
    }
  }
  $self->{'selectedCars'}=$tmpCars;
  #print $tmpCars->DESCR,"\n";
  return;
}

sub selectCar {
  my $self=shift;
  my $carPage = $WOApp->pageWithName("Car");
  #print "SELECTED CAR: ",$self->{'car'}->DESCR,"\n";
  $carPage->setSelectedCar($self->{'car'});
  return $carPage;
}

'WO::DodgeLite::SelectedCars';
# EOF
