# $Id: Sendmail.pl,v 1.1 1996/09/16 04:28:32 pedja Exp $
# Copyright 1996 TipTop Software

# You may freely distribute and reuse this code.
# Contributions to WOPerl component repository are welcome and greatly
# appreciated!

package WO::Sendmail;
use WOPerl;

@IVARS=qw(title from to subject body
	  fieldSize bodyRows bodyCols
	  errorStatus);
@ACTIONS=qw(callback);

############################################################################
use Socket;
$mailhost='mailhost';
$timeout=10;
$debug=1;

$zero_mask=undef;
# select() under WinNT does not like undef
vec($zero_mask,0,1)=0;

sub expect_code {
  my $n;
  my $mask='';
  my $buf='';
  vec($mask,fileno(SendMail_Socket),1)=1;
  $n=select($mask,$zero_mask,$zero_mask,$timeout);
  die "TIMEOUT: expect_code $_[0]" if $n<1;
  $n=sysread(SendMail_Socket,$buf,1024);
  if ($buf =~ "^$_[0] ") {
    print "OK: $buf" if $debug;
  } else { die "Expected code $_[0], got \"$buf\""; }
}

sub send_stuff {
  my $n;
  my $mask='';
  my $data="$_[0]\r\n";
  print ">> $data" if $debug;
  while (length($data)>0) {
    vec($mask,fileno(SendMail_Socket),1)=1;
    $n=select($zero_mask,$mask,$zero_mask,$timeout);
    die "TIMEOUT: send_stuff $_[0]" if $n<1;
    $n=send SendMail_Socket, $data, 0;
    die "Error during send" if $n<1;
    $data=substr($data,$n);
  }
}


sub sendmail {
  my ($to,$from,$subject,$body)=@_;
  my $mailhost_addr, $sin;

  socket(SendMail_Socket, PF_INET, SOCK_STREAM, getprotobyname('tcp'));
  if(0) {
    # This does not work under WinNT
    $mailhost_addr=inet_aton($mailhost) || die "Cannot resolve $mailhost";
    $sin=sockaddr_in(25,$mailhost_addr);
  } else {
    if($mailhost =~ /^(\d+)+\.(\d+)\.(\d+)\.(\d+)$/) {
      $mailhost_addr = pack('C4', $1, $2, $3, $4);
    } else {
      my(@x)=gethostbyname($mailhost);
      die "Cannot resolve $mailhost" unless @x;
      $mailhost_addr=$x[4];
    }
    $sin=pack('S n a4 x8',2,25,$mailhost_addr);
  }
  connect(SendMail_Socket,$sin)
    || die "Could not connect to socket 25 on host $mailhost";

  expect_code 220;
  send_stuff "HELO WOPerl";		expect_code 250;
  send_stuff "MAIL FROM:<$from>";	expect_code 250;
  send_stuff "RCPT TO:<$to>";		expect_code 250;
  send_stuff "DATA";			expect_code 354;
  send_stuff "To: $to";
  send_stuff "Subject: $subject";
  send_stuff "X-Url: http://www.tiptop.com/WOPerl/";
  send_stuff "";
  send_stuff "$body";
  send_stuff ".";			expect_code 250;
  send_stuff "QUIT";			expect_code 221;
  
  close SendMail_Socket;
}

############################################################################

sub awake {
  my($self)=@_;
  $self->{'title'}="Please enter email message";
  $self->{'to'}="";
  $self->{'from'}="";
  $self->{'subject'}="Feedback";
  $self->{'body'}="Type your message here...";
  $self->{'fieldSize'}=70;
  $self->{'bodyCols'}=76;
  $self->{'bodyRows'}=15;
  $self->{'errorStatus'}='';
  $self->{'callback'}=nil;
  return;
}

sub mailhost { return $mailhost; }
sub setMailhost { $mailhost=$_[1]; return; }

sub comment {
  my($self)=@_;
  return "(mailhost: " . &mailhost . ")"
    if $debug;
  return "";
}

sub doSendmail {
  my($self)=@_;
  if($debug) {
    print "SENDMAIL: ",$self->{'title'},"\n";
    print "From: ",$self->{'from'},"\n";
    print "To: ",$self->{'to'},"\n";
    print "Subject: ",$self->{'subject'},"\n";
    print "Message: ",$self->{'body'},"\n";
  }
  eval {
    sendmail
	$self->{'to'},
	$self->{'from'},
	$self->{'subject'},
	$self->{'body'};
  };
  $self->{'errorStatus'}=$@;
  print "ERROR: $@" if $debug && $@;
  return $self->{'callback'}->invoke;
}


'WO::Sendmail';
# EOF
