# $Id: Main.pl,v 1.1 1996/09/16 04:28:46 pedja Exp $

package WO::UsingWORequests::Main;
use WOPerl;

@PERSISTENT=qw(string1 string2);
@IVARS=qw(requestString urlRequestString);

sub awake {
  my($self)=@_;
  $self->{'requestString'} = nil;
  $self->{'urlRequestString'} = nil;
  return nil;
}

sub ok {
  return nil;
}

sub setRequestStringWithRequest {
  my($self,$request)=@_;
  my $i, $count, $key, $keys;
  my $value;
  my $formValues = $request->formValues;
  my $headers = $request->headers;
  my $content = $request->content;
    
  # Method line
  $self->{'requestString'} = "Method Line: " . $request->methodLine . "\n";
	    
  # Form values
  $self->{'requestString'} .= "Form Values:\n";
  $count = $formValues->count;
  $keys = $formValues->allKeys;
  for ($i=0; $i<$count; $i++) {
    $key = $keys->[$i]; #objectAtIndex($i);
    $self->{'requestString'} .= "\t$key: " . $formValues->{$key} . "\n";
  }
    
  # Headers
  $self->{'requestString'} .= "Headers:\n";

#  foreach $key (keys %$headers) {
#print "$key: ", $headers->{$key}, "\n";
#    $self->{'requestString'} .= "\t$key: " . $headers->{$key} . "\n";
#  }

#  while(($key,$value)=each(%$headers)) {
#print "$key: $value\n";
#    $self->{'requestString'} .= "\t$key: $value\n";
#  }

  $count = $headers->count;
  $keys = $headers->allKeys;
  for ($i=0; $i<$count ; $i++) {
    $key = $keys->[$i];
    $self->{'requestString'} .= "\t$key: " . $headers->{$key} . "\n";
  }
    
  # Document Root
  $self->{'requestString'} .="Document Root: " . $request->documentRoot . "\n";

  # Content
  $self->{'requestString'} .= "Content: " .
	NSString->alloc
	  ->initWithDataEncoding($content,$request->encoding)
	  ->autorelease
	. "\n";
#  return $self->{'requestString'};
}

sub setUrlRequestStringWithRequest {
  my($self,$request)=@_;
  # url
  $self->{'urlRequestString'} = "URL: " . $request->url . "\n";

  # urlApplicationHost
  $self->{'urlRequestString'} .= "Application Host: " .
	$request->urlApplicationHost . "\n";
	    
  # urlApplicationName
  $self->{'urlRequestString'} .= "Application Name: " .
	$request->urlApplicationName . "\n";

  # urlApplicationNumber
  $self->{'urlRequestString'} .= "Application Number: " .
	$request->urlApplicationNumber . "\n";
    
  # urlPageName
  $self->{'urlRequestString'} .= "Page Name: " .
	$request->urlPageName . "\n";
    
  # urlPrefix
  $self->{'urlRequestString'} .= "Prefix: " .
	$request->urlPrefix . "\n";
    
  # urlSenderID
  $self->{'urlRequestString'} .= "Sender ID: " .
	$request->urlSenderID . "\n";

  # urlStateID
  $self->{'urlRequestString'} .= "State ID: " .
	$request->urlStateID . "\n";
    
  # urlWebObjectsVersion
  $self->{'urlRequestString'} .= "WebObjects Version: " .
	$request->urlWebObjectsVersion . "\n";
  return;
}

sub willPrepareForRequestInContext {
  my($self,$request,$context)=@_;
  $self->setRequestStringWithRequest($request);
  $self->setUrlRequestStringWithRequest($request);
  return nil;
}

'WO::UsingWORequests::Main';  
# EOF
 